# Z-DC v1.04 by ZeD
#
# Purpose: Deposit Cash into a Citadel Treasury.
# Prompt: Citadel
# Usage: [Bot_name] Z-DC AmountToKeep/100000
#
setVar $tagline "Z-DC v1.05 by ZeD"
loadVar $PARM1
loadVar $COMMAND
loadVar $BOT_NAME
setVar $Parameter1 $PARM1
lowercase $Parameter1
setVar $CommandName $COMMAND
uppercase $CommandName
if ($CommandName = "0")
   setVar $CommandName "Z-DC"
end
gosub :comms_off

# Help
if ($Parameter1 = "help") or ($Parameter1 = "?")
   send "'*"
   send "-------------------*"
   send " "& $tagline &"*"
   send "-------------------*"
   send "Deposits credits into the citadel treasury.*"
   send " *"
   send "Prompt: Citadel*"
   send " *"
   send "Usage: ["& $BOT_NAME &"] "& $CommandName &" AmountToKeep*"
   send "  where AmountToKeep is the credits to keep divided by 100,000.*"
   send " *"
   send "Example:  "& $CommandName &" 10    - deposits all credits except 1,000,000.*"
   send " *"
   send "If AmountToKeep is left blank it keeps 100,001 credits.**"
   goto :FINISH
end

# Check Prompt
Send "*"
WaitFor "(?="
GetWord CURRENTLINE $prompt 1

If ($prompt <> "Citadel")
  send "'" $tagline ": Script Aborted: Must be at the CITADEL prompt.*"
  sound failed.WAV
  goto :FINISH
End

# Get Player Credits
gosub :PlayerInfo~InfoQuick
setVar $Cash $PlayerInfo~Credits
stripText $Cash ","
waitFor "(?=help)"


# Get Keepamount
Isnumber $isnum $Parameter1
If ($isnum = TRUE)
	IF ($Parameter1 < 1)
	   setVar $KeepAmt 100001
	ELSE
		setVar $KeepAmt ($Parameter1 * 100000)
	END
Else
	setVar $KeepAmt 100001
End

# Calculate and set Deposit Amount
setVar $DepositAmt ($Cash - $KeepAmt)
if ($DepositAmt < 0)
   setVar $CommasAdded $Cash
   gosub :AddCommas
   send "'" $tagline ": You only have " $CommasAdded " credits..*"
   sound failed.WAV
   goto :FINISH
end

# Deposit
send "t"
waitFor "Transfer To or From the Treasury (T/F) [F]?"
send "t"
waitFor "How much to transfer?"
send $DepositAmt "*"
setVar $CommasAdded $DepositAmt
gosub :AddCommas
waitfor "You have"
send "'" $tagline ": Deposited " $CommasAdded " credits into the Citadel Treasury.*"
sound ding.wav
goto :FINISH

:FINISH
gosub :ClearAllVars
gosub :comms_on
halt

# Subroutines

:AddCommas
# Set $CommasAdded variable to the number to be converted and call this routine.
# The commas will be added to the number and returned in the same variable.
if ($CommasAdded < 1000)
       #do nothing
elseif ($CommasAdded < 1000000)
       getLength $CommasAdded $len
       setVar $len ($len - 3)
       cutText $CommasAdded $tmp 1 $len
       cutText $CommasAdded $tmp1 ($len + 1) 999
       setVar $tmp $tmp & "," & $tmp1
       setVar $CommasAdded $tmp
elseif ($CommasAdded <= 999999999)
       getLength $CommasAdded $len
       setVar $len ($len - 6)
       cutText $CommasAdded $tmp 1 $len
       setVar $tmp $tmp & ","
       cutText $CommasAdded $tmp1 ($len + 1) 3
       setVar $tmp $tmp & $tmp1 & ","
       cutText $CommasAdded $tmp1 ($len + 4) 999
       setVar $tmp $tmp & $tmp1
       setVar $CommasAdded $tmp
end
return

:ClearAllVars
      SetVar $PARM1 "0"
      SetVar $PARM2 "0"
      SetVar $PARM3 "0"
      SetVar $PARM4 "0"
      SetVar $PARM5 "0"
      SetVar $PARM6 "0"
      SetVar $PARM7 "0"
      SetVar $PARM8 "0"
      SetVar $USER_COMMAND_LINE "0 0 0 0 0 0 0"
      SaveVar $PARM1
      SaveVar $PARM2
      SaveVar $PARM3
      SaveVar $PARM4
      SaveVar $PARM5
      SaveVar $PARM6
      SaveVar $PARM7
      SaveVar $PARM8
      SaveVar $USER_COMMAND_LINE
Return

:comms_on
     Send "|"
     WaitOn "all messages."
     GetWord CURRENTLINE $messages "1"
     IF ($messages <> "Displaying")
        Send "|"
     END
Return
:comms_off
     Send "|"
     WaitOn "all messages."
     GetWord CURRENTLINE $messages "1"
     IF ($messages <> "Silencing")
        Send "|"
     END
Return

# includes:

include "include\playerInfo"
