# Title: Z-Figs
# Author: Zed
# Copyright (c) 2010 by Archibald H. Vilanos III
# All Rights Reserved.
# Refreshes the FIGSEC Sector Parameter in the TWX Database.
SetVar $version "1.06"
SetVar $scriptname "Z-Figs"
SetVar $scripttitle "Zed's Fighter Refresh"
SetVar $Z_Lib~scriptname $scriptname
SetVar $Z_Lib~scripttitle $scripttitle
SetVar $Z_Lib~Version $version
GoSub :Z_Lib~INITLIB
Gosub :Z_Lib~CHECKONCE
Gosub :Z_Lib~CURRENTPLANET
SetVar $Z_Lib~setprompt "COMMAND"
Gosub :Z_Lib~PROMPT
Gosub :Z_Lib~COMMSOFF
LoadVar $z_lastfigrefresh
If ($z_lastfigrefresh = "0")
   SetVar $z_lastfigrefresh "None"
End
GetSectorParameter 2 "FIG_COUNT" $z_lastfigcount
If ($z_lastfigcount = "")
   SetVar $z_lastfigcount "0"
End
SetVar $z_figcount "0"
SetVar $Z_Lib~extra ANSI_10 & "- Counting Current Figs In Database..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $current "0"
SetVar $count "1"
While ($count <= SECTORS)
    GetSectorParameter $count "FIGSEC" $isfigged
    If ($isfigged = TRUE)
       SetVar $current ($current + 1)
    End
    SetVar $count ($count + 1)
End
SetVar $Z_Lib~extra ANSI_10 & "- Clearing Database..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $count "1"
While ($count <= SECTORS)
    SetSectorParameter $count "FIGSEC" FALSE
    SetVar $count ($count + 1)
End
SetVar $Z_Lib~extra ANSI_10 & "- Refreshing Figs..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $trigger2u "Deployed  Fighter  Scan"
:MONITOR
Gosub :Z_Lib~ANSI_OFF
SetTextLineTrigger 2u :FIGS $trigger2u
Send "g"
Pause
:FIGS
KillAllTriggers
SetTextLineTrigger figscan1 :STARTFIGSCAN "===================="
SetTextLineTrigger figsnone :ENDFIGSCAN "No fighters deployed"
SetTextLineTrigger figscan2 :ENDFIGSCAN "Total"
Pause
:STARTFIGSCAN
KillAllTriggers
SetTextLineTrigger figscan3 :SCANLINE
Pause
:SCANLINE
KillAllTriggers
SetVar $line CURRENTLINE
GetWordPos $line $pos "Total"
GetWordPos $line $pos2 "No fighters deployed"
If ($pos > 0)
	GetWord $line $z_deployed 1
	ReplaceText $z_deployed "T" ",000"
	ReplaceText $z_deployed "M" ",000,000"
	Goto :ENDFIGSCAN
ElseIf ($pos2 > 0)
   Goto :ENDFIGSCAN
Else
   GetWord $line $sectnum 1
   IsNumber $isnum $sectnum
   If ($isnum = TRUE)
      SetSectorParameter $sectnum "FIGSEC" TRUE
      SetVar $z_figcount ($z_figcount + 1)
   End
End
Goto :STARTFIGSCAN
:ENDFIGSCAN
KillAllTriggers
Gosub :Z_Lib~ANSI_ON
Waitfor "] (?=Help)? :"
SetPrecision 2
If ($z_lastfigcount > 0)
   SetVar $z_lastpercent (($z_lastfigcount * 100) / SECTORS)
Else
   SetVar $z_lastpercent "0"
End
If ($z_figcount > 0)
   SetVar $z_grid (($z_figcount * 100) / SECTORS)
Else
   SetVar $z_grid "0.00"
End
SetPrecision 0
SetVar $z_diff ($z_figcount - $z_lastfigcount)
SetPrecision 2
If ($z_diff <> 0)
   Setvar $z_diffperc (($z_diff * 100) / SECTORS)
Else
   Setvar $z_diffperc "0.00"
End
SetPrecision 0
Gosub :Z_Lib~RETURNTOPLANET
Gosub :Z_Lib~SYNC
Send "'*"
Send "---------------------------------------------------------------------*"
Send "Zed's Fighter Refresh v" & $Version & "*"
Send "---------------------------*"
Send "Database Check : " & $current & "*"
Send "-*"
Send "Last Refresh   : " & $z_lastfigrefresh & "*"
Send "Last Count     : " & $z_lastfigcount & "*"
Send "Grid Percent   : " & $z_lastpercent & "%*"
Send "-*"
Send "Current Count  : " & $z_figcount & "*"
Send "Current Grid   : " & $z_grid & "%*"
Send "-*"
Send "Difference     : " & $z_diff & "*"
Send "Percentage     : " & $z_diffperc & "%*"
Send "-*"
Send "Total Deployed : " & $z_deployed & "*"
Send "---------------------------------------------------------------------**"
Waitfor "Sub-space comm-link terminated"
SetVar $Z_Lib~extra ANSI_10 & "- Done !"
Gosub :Z_Lib~HEADER
Echo  "*"
Echo ANSI_10 & "Database Check : " & ANSI_3 & $current & "*"
Echo "*"
Echo ANSI_10 & "Last Refresh   : " & ANSI_7 & $z_lastfigrefresh & "*"
Echo ANSI_10 & "Last Count     : " & ANSI_7 & $z_lastfigcount & "*"
Echo ANSI_10 & "Grid Percent   : " & ANSI_7 & $z_lastpercent & "%*"
Echo  "*"
Echo ANSI_10 & "Current Count  : " & ANSI_15 & $z_figcount & "*"
Echo ANSI_10 & "Current Grid   : " & ANSI_15 & $z_grid & "%*"
Echo  "*"
Echo ANSI_10 & "Difference     : " & ANSI_14 & $z_diff & "*"
Echo ANSI_10 & "Percentage     : " & ANSI_14 & $z_diffperc & "%*"
Echo "*"
Echo ANSI_10 & "Total Deployed : " & ANSI_7 & $z_deployed
Gosub :Z_Lib~REDLINE
Echo  "*"
SetSectorParameter 2 "FIG_COUNT" $z_figcount
SetVar $z_lastfigrefresh (DATE & " - " & TIME)
SaveVar $z_lastfigrefresh
Goto :FINISH
:FINISH
Gosub :Z_Lib~COMMSON
Halt
# Includes
Include include\Z_Lib.ts
# ZeD Compiled: Tue 07/06/2011 -  5:59:58.59 
# ZeD Compiled: Wed 22/06/2011 - 16:45:16.07 
