#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Z-Installer.ico
#AutoIt3Wrapper_Outfile=Z-Installer.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Fileversion=2.1.5.0
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.8.1
 Author:         Archibald H. Vilanos III

 Script Function:
	Installer for TWX, Putty, and Z-Bot

#ce ----------------------------------------------------------------------------

#include <GUIConstantsEx.au3>
#include <File.au3>
#include <WindowsConstants.au3>
#include <String.au3>
#include <Array.au3>
#include <WinAPI.au3>
#include <StaticConstants.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <Date.au3>
#include <Misc.au3>
#include <GuiEdit.au3>
#include <ScrollBarConstants.au3>



Global $scripttitle = "Z-Installer"
Global $scriptauthor = "Archibald H. Vilanos III"
Global $copyright = "(c) 2014"
Global $version = "2.1.5"
Global $tagline = $scripttitle & " v" & $version & " " & $copyright & " by " & $scriptauthor
If WinExists($tagline) Then
	WinActivate($tagline)
	WinMove ($tagline, "", 10, 10)
	Exit
EndIf


Global $twxrootfolder = "C:\TWX"
Global $twxscriptsfolder = $twxrootfolder & "\scripts"
Global $twxincludefolder = $twxscriptsfolder & "\include"
Global $twxdatafolder = $twxrootfolder & "\data"
Global $puttyfolder = $twxrootfolder & "\Putty"

Global $deploytwx = True
Global $deployversion = _Iif((@OSVersion = "WIN_7" or @OSVersion = "WIN_8"), "Win7", "XP")
Global $deployputty = True
Global $deployzbot = True

Global $configureputty = True

$originalfolder = @WorkingDir
$window_Main = GUICreate($tagline, 480, 240, -1, -1, BitOr($GUI_SS_DEFAULT_GUI, $WS_EX_LAYERED))
GUISetBkColor(0xbcbcbc, $window_Main)
GUISetState(@SW_SHOW, $window_Main)


GUISetFont (16, 800, 4, "Arial Black")
$Label_Title = GUICtrlCreateLabel($scripttitle, 6, 3, 180, 32, $SS_CENTER)
$foreground = "0x000000"
$background = "0xbcbcbc"
GUICtrlSetColor ($Label_Title, $foreground)
GUICtrlSetBkColor ($Label_Title, $background)

GUISetFont (10, 400, 0, "Arial")
$Button_Back = GUICtrlCreateButton("BACK", 340, 220, 60, 18)
GUICtrlSetState($Button_Back, $GUI_DISABLE + $GUI_HIDE)
$Button_Next = GUICtrlCreateButton("NEXT", 410, 220, 60, 18)
GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
GUISetFont (10, 400, 0, "Arial")
$Button_Special = GUICtrlCreateButton("SELECT ANOTHER FOLDER", 208, 100, 200, 20)
GUICtrlSetState($Button_Special, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (10, 800, 4, "Arial")
$Label_Line1_Label = GUICtrlCreateLabel("TWX Root Folder:", 6, 45, 120, 20, $SS_CENTER)
GUICtrlSetColor ($Label_Line1_Label, $foreground)
GUICtrlSetBkColor ($Label_Line1_Label, $background)
GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (10, 400, 0, "Arial")
$Label_Line1_Content = GUICtrlCreateLabel($twxrootfolder, 130, 48, 340, 16, $SS_CENTER)
GUICtrlSetColor ($Label_Line1_Content, $foreground)
GUICtrlSetBkColor ($Label_Line1_Content, $background)
GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (10, 800, 0, "Arial")
$Label_Line2_Label = GUICtrlCreateLabel("Install Folder:  ", 6, 85, 120, 16, $SS_RIGHT)
GUICtrlSetColor ($Label_Line2_Label, $foreground)
GUICtrlSetBkColor ($Label_Line2_Label, $background)
GUICtrlSetState($Label_Line2_Label, $GUI_DISABLE + $GUI_HIDE)

$group_1 = GUICtrlCreateGroup ( "", 4, 70, 472, 80)

GUISetFont (8, 800, 0, "Arial")
$Label_Line2_Content = GUICtrlCreateLabel($twxrootfolder, 130, 88, 340, 12)
GUICtrlSetColor ($Label_Line2_Content, $foreground)
GUICtrlSetBkColor ($Label_Line2_Content, $background)
GUICtrlSetState($Label_Line2_Content, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (10, 800, 0, "Arial")
$Label_Line5_Label = GUICtrlCreateLabel("Shortcuts:  ", 6, 127, 120, 16, $SS_RIGHT)
GUICtrlSetColor ($Label_Line5_Label, $foreground)
GUICtrlSetBkColor ($Label_Line5_Label, $background)
GUICtrlSetState($Label_Line5_Label, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (8, 800, 0, "Arial")
$Label_Line5_Content = GUICtrlCreateLabel("Creating Desktop and Start Menu Shortcuts", 130, 130, 340, 12)
GUICtrlSetColor ($Label_Line5_Content, $foreground)
GUICtrlSetBkColor ($Label_Line5_Content, $background)
GUICtrlSetState($Label_Line5_Content, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (10, 800, 0, "Arial")
$Label_Line3_Label = GUICtrlCreateLabel("Components:  ", 6, 105, 120, 16, $SS_RIGHT)
GUICtrlSetColor ($Label_Line3_Label, $foreground)
GUICtrlSetBkColor ($Label_Line3_Label, $background)
GUICtrlSetState($Label_Line3_Label, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (8, 800, 0, "Arial")
$Label_Line3_Content = GUICtrlCreateLabel("Components", 130, 108, 340, 12)
GUICtrlSetColor ($Label_Line3_Content, $foreground)
GUICtrlSetBkColor ($Label_Line3_Content, $background)
GUICtrlSetState($Label_Line3_Content, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (12, 800, 0, "Arial")
$Label_Line4_Label = GUICtrlCreateLabel("Ready?", 6, 160, 120, 20, $SS_CENTER)
GUICtrlSetColor ($Label_Line4_Label, $foreground)
GUICtrlSetBkColor ($Label_Line4_Label, $background)
GUICtrlSetState($Label_Line4_Label, $GUI_DISABLE + $GUI_HIDE)

GUISetFont (10, 400, 0, "Arial")
$Label_Line4_Content = GUICtrlCreateLabel("Click NEXT to begin the installation..", 130, 163, 340, 16, $SS_CENTER)
GUICtrlSetColor ($Label_Line4_Content, $foreground)
GUICtrlSetBkColor ($Label_Line4_Content, $background)
GUICtrlSetState($Label_Line4_Content, $GUI_DISABLE + $GUI_HIDE)



GUISetFont (8, 400, 0, "Arial")
$Checkbox_DesktopShortcuts = GUICtrlCreateCheckbox("Create DeskTop Shortcuts", 130, 80, -1, -1, $BS_AUTOCHECKBOX)
GUICtrlSetState($Checkbox_DesktopShortcuts, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)

$Checkbox_StartMenuShortcuts = GUICtrlCreateCheckbox("Create Start Menu Shortcuts", 130, 124, -1, -1, $BS_AUTOCHECKBOX)
GUICtrlSetState($Checkbox_StartMenuShortcuts, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)

$Checkbox_DeployTWX = GUICtrlCreateCheckbox("Install TWX Proxy", 30, 80,-1, -1, $BS_AUTOCHECKBOX)
GUICtrlSetState($Checkbox_DeployTWX, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)

$Checkbox_DeployPutty = GUICtrlCreateCheckbox("Install Putty Telnet Client", 30, 102,-1, -1, $BS_AUTOCHECKBOX)
GUICtrlSetState($Checkbox_DeployPutty, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)

$Checkbox_ConfigurePutty = GUICtrlCreateCheckbox("Configure Putty (will edit registry)", 220, 102,-1, -1, $BS_AUTOCHECKBOX)
GUICtrlSetState($Checkbox_ConfigurePutty, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)

$Checkbox_DeployZBot = GUICtrlCreateCheckbox("Install Z-Bot and the ZedPack", 30, 124,-1, -1, $BS_AUTOCHECKBOX)
GUICtrlSetState($Checkbox_DeployZBot, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)

$Radio_XPVersion = GUICtrlCreateRadio("for XP", 220, 80, -1, -1)
$Radio_WIN7Version = GUICtrlCreateRadio("for WIN7", 300, 80, -1, -1)

If $deployversion = "Win7" Then
	GUICtrlSetState($Radio_WIN7Version, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)
	GUICtrlSetState($Radio_XPVersion, $GUI_DISABLE + $GUI_HIDE)
Else
	GUICtrlSetState($Radio_WIN7Version, $GUI_DISABLE + $GUI_HIDE)
	GUICtrlSetState($Radio_XPVersion, $GUI_DISABLE + $GUI_HIDE + $GUI_CHECKED)
EndIf

GUISetFont (8, 400, 0, "Arial")
$Label_Warn = GUICtrlCreateLabel("Fresh Installation", 200, 20, 250, 16, $SS_RIGHT)
GUICtrlSetColor ($Label_Warn, $foreground)
GUICtrlSetBkColor ($Label_Warn, $background)
GUICtrlSetState($Label_Warn, $GUI_DISABLE + $GUI_HIDE)





$level = 1
While True
	Select
		Case $level = 1
			$direxists = False
			If DirGetSize($twxrootfolder) <> -1 Then
				$direxists = True
				$warn = "Folder Exists"
				$folderexists = True
				If FileExists($twxrootfolder & "\TWXProxy.exe") = True Then
					$folderoldinstall = True
					$foldernotempty = True
					$warn = "Existing Installation"
				ElseIf FileFindFirstFile($twxrootfolder & "\*.*") <> -1 Then
					$foldernotempty = True
					$warn = "Folder is NOT empty !"
				EndIf
			Else
				$warn = "Install will create this folder"
				$folderexists = False
			EndIf
			GUICtrlSetData($Label_Line1_Label, "TWX Root Folder")
			GUICtrlSetData($Label_Line1_Content, $twxrootfolder)
			GUICtrlSetData($Label_Warn, $warn)

			GUICtrlSetState($Label_Line1_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line1_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Warn, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Next, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Special, $GUI_ENABLE + $GUI_SHOW)

			While True
				$msg = GUIGetMsg(1)
				Select
					Case ($msg[0] = $GUI_EVENT_CLOSE)
						If QuitEarly() = True Then
							ExitLoop 2
						EndIf
					Case ($msg[0] = $Button_Next)
						GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Warn, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Special, $GUI_DISABLE + $GUI_HIDE)
						$level = 2
						ExitLoop
					Case ($msg[0] = $Button_Back)
					Case ($msg[0] = $Button_Special)
						$temp = FileSelectFolder("Select/Create the TWX Root Folder", "C:\", 7, $twxrootfolder, $window_Main)
						If ($temp <> "") Then
							$twxrootfolder = $temp
							$twxscriptsfolder = $twxrootfolder & "\scripts"
							$twxincludefolder = $twxscriptsfolder & "\include"
							$twxdatafolder = $twxrootfolder & "\data"
							$puttyfolder = $twxrootfolder & "\Putty"
						EndIf
						ExitLoop
				EndSelect
			WEnd


		Case $level = 2

			GUICtrlSetData($Label_Line1_Label, "Components")
			GUICtrlSetData($Label_Line1_Content, "Select the components to install")
			GUICtrlSetState($Label_Line1_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line1_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Next, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Back, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Checkbox_DeployTWX, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Checkbox_DeployPutty, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Checkbox_DeployZBot, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Radio_XPVersion, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Radio_WIN7Version, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Checkbox_ConfigurePutty, $GUI_ENABLE + $GUI_SHOW)

			While True

				$msg = GUIGetMsg(1)
				Select
					Case ($msg[0] = $GUI_EVENT_CLOSE)
						If QuitEarly() = True Then
							ExitLoop 2
						EndIf
					Case ($msg[0] = $Button_Next)
						GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Back, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DeployTWX, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DeployPutty, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DeployZBot, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Radio_XPVersion, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Radio_WIN7Version, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_ConfigurePutty, $GUI_DISABLE + $GUI_HIDE)

						$deploytwx = GUICtrlRead($Checkbox_DeployTWX)
						If $deploytwx = 4 then $deploytwx = False
						If $deploytwx = 1 then $deploytwx = True
						$deployversion = GUICtrlRead($Radio_WIN7Version)
						If $deployversion = 4 then $deployversion = "XP"
						If $deployversion = 1 then $deployversion = "Win7"
						$deployputty = GUICtrlRead($Checkbox_DeployPutty)
						If $deployputty = 4 then $deployputty = False
						If $deployputty = 1 then $deployputty = True
						$deployzbot = GUICtrlRead($Checkbox_DeployZBot)
						If $deployzbot = 4 then $deployzbot = False
						If $deployzbot = 1 then $deployzbot = True
						$configureputty = GUICtrlRead($Checkbox_ConfigurePutty)
						If $configureputty = 4 then $configureputty = False
						If $configureputty = 1 then $configureputty = True



						$level = 3
						ExitLoop
					Case ($msg[0] = $Button_Back)
						GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Back, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DeployTWX, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DeployPutty, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DeployZBot, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Radio_XPVersion, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Radio_WIN7Version, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_ConfigurePutty, $GUI_DISABLE + $GUI_HIDE)

						$deploytwx = GUICtrlRead($Checkbox_DeployTWX)
						If $deploytwx = 4 then $deploytwx = False
						If $deploytwx = 1 then $deploytwx = True
						$deployversion = GUICtrlRead($Radio_WIN7Version)
						If $deployversion = 4 then $deployversion = "XP"
						If $deployversion = 1 then $deployversion = "Win7"
						$deployputty = GUICtrlRead($Checkbox_DeployPutty)
						If $deployputty = 4 then $deployputty = False
						If $deployputty = 1 then $deployputty = True
						$deployzbot = GUICtrlRead($Checkbox_DeployZBot)
						If $deployzbot = 4 then $deployzbot = False
						If $deployzbot = 1 then $deployzbot = True
						$level = 1
						ExitLoop
					Case ($msg[0] = $Button_Special)
				EndSelect
			WEnd

		Case $level = 3

			GUICtrlSetData($Label_Line1_Label, "Shortcuts")
			GUICtrlSetData($Label_Line1_Content, "Create Shortcuts for the desktop and start menu")

			GUICtrlSetState($Label_Line1_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line1_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Next, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Back, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Checkbox_DesktopShortcuts, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Checkbox_StartMenuShortcuts, $GUI_ENABLE + $GUI_SHOW)

			While True

				$msg = GUIGetMsg(1)
				Select
					Case ($msg[0] = $GUI_EVENT_CLOSE)
						If QuitEarly() = True Then
							ExitLoop 2
						EndIf
					Case ($msg[0] = $Button_Next)
						GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Back, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DesktopShortcuts, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_StartMenuShortcuts, $GUI_DISABLE + $GUI_HIDE)


						$desktopshortcuts = GUICtrlRead($Checkbox_DesktopShortcuts)
						If $desktopshortcuts = 4 then $desktopshortcuts = False
						If $desktopshortcuts = 1 then $desktopshortcuts = True
						$startmenushortcuts = GUICtrlRead($Checkbox_StartMenuShortcuts)
						If $startmenushortcuts = 4 then $startmenushortcuts = False
						If $startmenushortcuts = 1 then $startmenushortcuts = True

						$level = 4
						ExitLoop
					Case ($msg[0] = $Button_Back)
						GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Back, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_DesktopShortcuts, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Checkbox_StartMenuShortcuts, $GUI_DISABLE + $GUI_HIDE)

						$desktopshortcuts = GUICtrlRead($Checkbox_DesktopShortcuts)
						If $desktopshortcuts = 4 then $desktopshortcuts = False
						If $desktopshortcuts = 1 then $desktopshortcuts = True
						$startmenushortcuts = GUICtrlRead($Checkbox_StartMenuShortcuts)
						If $startmenushortcuts = 4 then $startmenushortcuts = False
						If $startmenushortcuts = 1 then $startmenushortcuts = True
						$level = 2
						ExitLoop
					Case ($msg[0] = $Button_Special)
				EndSelect
			WEnd
		Case $level = 4
			GUICtrlSetData($Label_Line1_Label, "Review")
			GUICtrlSetData($Label_Line1_Content, "These are your settings. Click BACK to change them.")

			GUICtrlSetData($Label_Line2_Label, "TWX Root Folder:  ")
			GUICtrlSetData($Label_Line2_Content, $twxrootfolder)

			If $desktopshortcuts = True and $startmenushortcuts = true Then
				GUICtrlSetData($Label_Line5_Content, "Creating Both Desktop and Start Menu shortcuts")
			ElseIf $desktopshortcuts = True Then
				GUICtrlSetData($Label_Line5_Content, "Creating Desktop Shortcut Only")
			ElseIf $startmenushortcuts = True Then
				GUICtrlSetData($Label_Line5_Content, "Creating Start Menu Shortcut Only")
			Else
				GUICtrlSetData($Label_Line5_Content, "No Shortcuts")
			EndIf

			$tempstring = ""
			If ($deploytwx = True) Then
				$tempstring = $tempstring & "TWX for " & $deployversion & "     "
			EndIf
			If ($deployputty = True) Then
				If ($configureputty = True) Then
					$tempstring = $tempstring & "Putty-Configured    "
				Else
					$tempstring = $tempstring & "Putty     "
				EndIf
			EndIf

			If ($deployzbot = True) Then
				$tempstring = $tempstring & "Z-Bot"
			EndIf


			GUICtrlSetData($Label_Line3_Content, $tempstring)


			GUICtrlSetState($Label_Warn, $GUI_ENABLE + $GUI_SHOW)

			GUICtrlSetState($Label_Line1_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line1_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line2_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line2_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line3_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line3_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line4_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line4_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line5_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line5_Content, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Next, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Button_Back, $GUI_ENABLE + $GUI_SHOW)

			While True

				$msg = GUIGetMsg(1)
				Select
					Case ($msg[0] = $GUI_EVENT_CLOSE)
						If QuitEarly() = True Then
							ExitLoop 2
						EndIf
					Case ($msg[0] = $Button_Next)
						GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line2_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line2_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line3_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line3_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line4_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line4_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line5_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line5_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Back, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Warn, $GUI_DISABLE + $GUI_HIDE)

						$level = 5
						ExitLoop
					Case ($msg[0] = $Button_Back)
						GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line1_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line2_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line2_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line3_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line3_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line4_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line4_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line5_Label, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Line5_Content, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Next, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Button_Back, $GUI_DISABLE + $GUI_HIDE)
						GUICtrlSetState($Label_Warn, $GUI_DISABLE + $GUI_HIDE)

						$level = 3
						ExitLoop
					Case ($msg[0] = $Button_Special)
				EndSelect
			WEnd
		Case $level = 5
			GUICtrlSetState($group_1, $GUI_HIDE)
			GUICtrlSetState($Label_Line1_Label, $GUI_ENABLE + $GUI_SHOW)
			GUICtrlSetState($Label_Line1_Content, $GUI_ENABLE + $GUI_SHOW)

			GUICtrlSetData($Label_Line1_Label, "Installing")
			If $deploytwx = True Then
				GUICtrlSetData($Label_Line1_Content, "TWX Proxy for " & $deployversion)
				DeployTWX()
			EndIf
			If $deployputty = True Then
				GUICtrlSetData($Label_Line1_Content, "Putty Telnet Client")
				DeployPutty()
			EndIf
			If $deployzbot = True Then
				GUICtrlSetData($Label_Line1_Content, "Z-Bot and the ZedPack")
				DeployZBot()
			EndIf

			If ($desktopshortcuts = True) or ($desktopshortcuts = True) Then
				GUICtrlSetData($Label_Line1_Content, "Creating Shorcuts")
				If ($desktopshortcuts = True) Then
					CreateDesktopShortCut()
				EndIf
				If ($startmenushortcuts = True) Then
					CreateStartMenuShortCut()
				EndIf
			EndIf

			GUICtrlSetState($Label_Line1_Label, $GUI_DISABLE + $GUI_HIDE)
			GUICtrlSetData($Label_Line1_Content, "Installation Complete !")

			FileChangeDir($twxrootfolder)

			GUICtrlSetState($Button_Next, $GUI_ENABLE + $GUI_SHOW)

			GUICtrlSetData($Button_Next, "Finish")

			While True

				$msg = GUIGetMsg(1)
				Select
					Case ($msg[0] = $GUI_EVENT_CLOSE)
						ExitLoop 2
					Case ($msg[0] = $Button_Next)
						ExitLoop 2
				EndSelect
			WEnd
	EndSelect
WEnd



; Finish
Exit

Func DeployZBot()
	If DirGetSize($twxscriptsfolder) = -1 Then
		DirCreate($twxscriptsfolder)
	EndIf

	FileInstall("ZedPack\Z-Bot Installation Notes.txt", $twxrootfolder & "\Z-Bot Installation Notes.txt", 1)
	FileInstall("ZedPack\TWX_Root\alert.wav", $twxrootfolder & "\alert.wav", 1)
	FileInstall("ZedPack\TWX_Root\ClearTWX.cmd", $twxrootfolder & "\ClearTWX.cmd", 1)
	FileInstall("ZedPack\TWX_Root\ClearTWXbackups.cmd", $twxrootfolder & "\ClearTWXbackups.cmd", 1)
	FileInstall("ZedPack\TWX_Root\cuckoclk.wav", $twxrootfolder & "\cuckoclk.wav", 1)
	FileInstall("ZedPack\TWX_Root\ding.wav", $twxrootfolder & "\ding.wav", 1)
	FileInstall("ZedPack\TWX_Root\failed.wav", $twxrootfolder & "\failed.wav", 1)
	FileInstall("ZedPack\TWX_Root\pdropalert.wav", $twxrootfolder & "\pdropalert.wav", 1)
	FileInstall("ZedPack\TWX_Root\proximity.wav", $twxrootfolder & "\proximity.wav", 1)
	FileInstall("ZedPack\TWX_Root\z_page.wav", $twxrootfolder & "\z_page.wav", 1)
	FileInstall("ZedPack\ZedPack-Readme.zip", $twxrootfolder & "\ZedPack-Readme.zip", 1)

	FileInstall("ZedPack\TWX_Root\scripts\_ck_buydown.cts", $twxscriptsfolder & "\_ck_buydown.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\_ck_equip_haggle_tracker.cts", $twxscriptsfolder & "\_ck_equip_haggle_tracker.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\_ck_planet_nego.cts", $twxscriptsfolder & "\_ck_planet_nego.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z_ck_buydown.cts", $twxscriptsfolder & "\z_ck_buydown.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z2_worldtrade.cts", $twxscriptsfolder & "\z2_worldtrade.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-armourer.cts", $twxscriptsfolder & "\z-armourer.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-backdoor.cts", $twxscriptsfolder & "\z-backdoor.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-bot.cts", $twxscriptsfolder & "\z-bot.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-call.cts", $twxscriptsfolder & "\z-call.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-coloniser.cts", $twxscriptsfolder & "\z-coloniser.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-commsguard.cts", $twxscriptsfolder & "\z-commsguard.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-decash.cts", $twxscriptsfolder & "\z-decash.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-fetch.cts", $twxscriptsfolder & "\z-fetch.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-figmon.cts", $twxscriptsfolder & "\z-figmon.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-figs.cts", $twxscriptsfolder & "\z-figs.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-limps.cts", $twxscriptsfolder & "\z-limps.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-listgridder.cts", $twxscriptsfolder & "\z-listgridder.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-login.cts", $twxscriptsfolder & "\z-login.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-mines.cts", $twxscriptsfolder & "\z-mines.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-ontime.cts", $twxscriptsfolder & "\z-ontime.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-oreup.cts", $twxscriptsfolder & "\z-oreup.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-panel.cts", $twxscriptsfolder & "\z-panel.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-pdriver.cts", $twxscriptsfolder & "\z-pdriver.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zpsst.cts", $twxscriptsfolder & "\zpsst.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-rescue.cts", $twxscriptsfolder & "\z-rescue.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-safetynet.cts", $twxscriptsfolder & "\z-safetynet.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-scout.cts", $twxscriptsfolder & "\z-scout.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-sectorlister.cts", $twxscriptsfolder & "\z-sectorlister.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-sptool.cts", $twxscriptsfolder & "\z-sptool.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-strip.cts", $twxscriptsfolder & "\z-strip.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-switchbot.cts", $twxscriptsfolder & "\z-switchbot.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-transcash.cts", $twxscriptsfolder & "\z-transcash.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-unload.cts", $twxscriptsfolder & "\z-unload.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zupgrade.cts", $twxscriptsfolder & "\zupgrade.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\z-watch.cts", $twxscriptsfolder & "\z-watch.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zwsst.cts", $twxscriptsfolder & "\zwsst.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zkazi.cts", $twxscriptsfolder & "\zkazi.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zmerch.cts", $twxscriptsfolder & "\zmerch.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zminesweep.cts", $twxscriptsfolder & "\zminesweep.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zpimp.cts", $twxscriptsfolder & "\zpimp.cts", 1)
	FileInstall("ZedPack\TWX_Root\scripts\zugrid.cts", $twxscriptsfolder & "\zugrid.cts", 1)
EndFunc

Func DeployPutty()
	If DirGetSize($puttyfolder) = -1 Then
		DirCreate($puttyfolder)
	EndIf
	FileInstall("TWX\Putty\putty.exe", $puttyfolder & "\putty.exe", 1)
	FileInstall("TWX\Putty\puttydoc.txt", $puttyfolder & "\puttydoc.txt", 1)
	FileInstall("TWX\Putty\SetUpPuttyForTradeWars.reg", $puttyfolder & "\SetUpPuttyForTradeWars.reg", 1)
	FileInstall("TWX\Putty\SetUpPuttyForTradeWarsReadMe.txt", $puttyfolder & "\SetUpPuttyForTradeWarsReadMe.txt", 1)
	If $configureputty = True Then
		ShellExecuteWait($puttyfolder & "\SetUpPuttyForTradeWars.reg", "", $puttyfolder, "open")
	EndIf
EndFunc

Func DeployTWX()
	If DirGetSize($twxrootfolder) = -1 Then
		DirCreate($twxrootfolder)
	EndIf
	If DirGetSize($twxscriptsfolder) = -1 Then
		DirCreate($twxscriptsfolder)
	EndIf
	If DirGetSize($twxdatafolder) = -1 Then
		DirCreate($twxdatafolder)
	EndIf
	If DirGetSize($twxincludefolder) = -1 Then
		DirCreate($twxincludefolder)
	EndIf
	If $deployversion = "Win7" Then
		FileInstall("TWX\TWXProxy_win7.exe", $twxrootfolder & "\TWXProxy.exe", 1)
	Else
		FileInstall("TWX\TWXProxy_204.exe", $twxrootfolder & "\TWXProxy.exe", 1)
	EndIf
	FileInstall("TWX\CapEdit.exe", $twxrootfolder & "\CapEdit.exe", 1)
	FileInstall("TWX\changes.txt", $twxrootfolder & "\changes.txt", 1)
	FileInstall("TWX\pack2.html", $twxrootfolder & "\pack2.html", 1)
	FileInstall("TWX\PreComp.exe", $twxrootfolder & "\PreComp.exe", 1)
	FileInstall("TWX\Readme.txt", $twxrootfolder & "\Readme.txt", 1)
	FileInstall("TWX\script.html", $twxrootfolder & "\script.html", 1)
	FileInstall("TWX\TWXC.exe", $twxrootfolder & "\TWXC.exe", 1)

	FileInstall("TWX\scripts\1_ECol.ts", $twxscriptsfolder & "\1_ECol.ts", 1)
	FileInstall("TWX\scripts\1_KeepAlive.ts", $twxscriptsfolder & "\1_KeepAlive.ts", 1)
	FileInstall("TWX\scripts\1_Login.ts", $twxscriptsfolder & "\1_Login.ts", 1)
	FileInstall("TWX\scripts\1_Move.ts", $twxscriptsfolder & "\1_Move.ts", 1)
	FileInstall("TWX\scripts\1_MoveCol.ts", $twxscriptsfolder & "\1_MoveCol.ts", 1)
	FileInstall("TWX\scripts\1_MoveFig.ts", $twxscriptsfolder & "\1_MoveFig.ts", 1)
	FileInstall("TWX\scripts\1_Port.ts", $twxscriptsfolder & "\1_Port.ts", 1)
	FileInstall("TWX\scripts\1_PortFast.ts", $twxscriptsfolder & "\1_PortFast.ts", 1)
	FileInstall("TWX\scripts\1_Scout.ts", $twxscriptsfolder & "\1_Scout.ts", 1)
	FileInstall("TWX\scripts\1_SSM.ts", $twxscriptsfolder & "\1_SSM.ts", 1)
	FileInstall("TWX\scripts\1_SST.ts", $twxscriptsfolder & "\1_SST.ts", 1)
	FileInstall("TWX\scripts\1_TCol.ts", $twxscriptsfolder & "\1_TCol.ts", 1)
	FileInstall("TWX\scripts\1_Trade.ts", $twxscriptsfolder & "\1_Trade.ts", 1)
	FileInstall("TWX\scripts\1_ZTM.ts", $twxscriptsfolder & "\1_ZTM.ts", 1)
	FileInstall("TWX\scripts\1_ZTMFast.ts", $twxscriptsfolder & "\1_ZTMFast.ts", 1)
	FileInstall("TWX\scripts\2_Build.ts", $twxscriptsfolder & "\2_Build.ts", 1)
	FileInstall("TWX\scripts\2_BuyDown.ts", $twxscriptsfolder & "\2_BuyDown.ts", 1)
	FileInstall("TWX\scripts\2_Col.ts", $twxscriptsfolder & "\2_Col.ts", 1)
	FileInstall("TWX\scripts\2_Evil.ts", $twxscriptsfolder & "\2_Evil.ts", 1)
	FileInstall("TWX\scripts\2_Find.ts", $twxscriptsfolder & "\2_Find.ts", 1)
	FileInstall("TWX\scripts\2_Gather.ts", $twxscriptsfolder & "\2_Gather.ts", 1)
	FileInstall("TWX\scripts\2_MassColonise.ts", $twxscriptsfolder & "\2_MassColonise.ts", 1)
	FileInstall("TWX\scripts\2_MassUpgrade.ts", $twxscriptsfolder & "\2_MassUpgrade.ts", 1)
	FileInstall("TWX\scripts\2_Ping.ts", $twxscriptsfolder & "\2_Ping.ts", 1)
	FileInstall("TWX\scripts\2_Probe.ts", $twxscriptsfolder & "\2_Probe.ts", 1)
	FileInstall("TWX\scripts\2_Query.ts", $twxscriptsfolder & "\2_Query.ts", 1)
	FileInstall("TWX\scripts\2_SDF.ts", $twxscriptsfolder & "\2_SDF.ts", 1)
	FileInstall("TWX\scripts\2_SDT.ts", $twxscriptsfolder & "\2_SDT.ts", 1)
	FileInstall("TWX\scripts\2_Sentinel.ts", $twxscriptsfolder & "\2_Sentinel.ts", 1)
	FileInstall("TWX\scripts\2_SSF.ts", $twxscriptsfolder & "\2_SSF.ts", 1)
	FileInstall("TWX\scripts\2_SST.ts", $twxscriptsfolder & "\2_SST.ts", 1)
	FileInstall("TWX\scripts\2_WorldSSM.ts", $twxscriptsfolder & "\2_WorldSSM.ts", 1)
	FileInstall("TWX\scripts\2_WorldTrade.ts", $twxscriptsfolder & "\2_WorldTrade.ts", 1)

	FileInstall("TWX\scripts\include\Approach.ts", $twxincludefolder & "\Approach.ts", 1)
	FileInstall("TWX\scripts\include\Cache.ts", $twxincludefolder & "\Cache.ts", 1)
	FileInstall("TWX\scripts\include\Capture.ts", $twxincludefolder & "\Capture.ts", 1)
	FileInstall("TWX\scripts\include\CheckCIM.ts", $twxincludefolder & "\CheckCIM.ts", 1)
	FileInstall("TWX\scripts\include\CheckCLV.ts", $twxincludefolder & "\CheckCLV.ts", 1)
	FileInstall("TWX\scripts\include\CheckOnline.ts", $twxincludefolder & "\CheckOnline.ts", 1)
	FileInstall("TWX\scripts\include\Colonise.ts", $twxincludefolder & "\Colonise.ts", 1)
	FileInstall("TWX\scripts\include\Evil.ts", $twxincludefolder & "\Evil.ts", 1)
	FileInstall("TWX\scripts\include\FastSST.ts", $twxincludefolder & "\FastSST.ts", 1)
	FileInstall("TWX\scripts\include\FindProduct.ts", $twxincludefolder & "\FindProduct.ts", 1)
	FileInstall("TWX\scripts\include\GamePrefs.ts", $twxincludefolder & "\GamePrefs.ts", 1)
	FileInstall("TWX\scripts\include\Gather.ts", $twxincludefolder & "\Gather.ts", 1)
	FileInstall("TWX\scripts\include\GetAttack.ts", $twxincludefolder & "\GetAttack.ts", 1)
	FileInstall("TWX\scripts\include\GetTarget.ts", $twxincludefolder & "\GetTarget.ts", 1)
	FileInstall("TWX\scripts\include\Haggle.ts", $twxincludefolder & "\Haggle.ts", 1)
	FileInstall("TWX\scripts\include\Header.ts", $twxincludefolder & "\Header.ts", 1)
	FileInstall("TWX\scripts\include\Land.ts", $twxincludefolder & "\Land.ts", 1)
	FileInstall("TWX\scripts\include\MakePlanet.ts", $twxincludefolder & "\MakePlanet.ts", 1)
	FileInstall("TWX\scripts\include\MassColonise.ts", $twxincludefolder & "\MassColonise.ts", 1)
	FileInstall("TWX\scripts\include\MassUpgrade.ts", $twxincludefolder & "\MassUpgrade.ts", 1)
	FileInstall("TWX\scripts\include\Move.ts", $twxincludefolder & "\Move.ts", 1)
	FileInstall("TWX\scripts\include\MoveProduct.ts", $twxincludefolder & "\MoveProduct.ts", 1)
	FileInstall("TWX\scripts\include\MoveShip.ts", $twxincludefolder & "\MoveShip.ts", 1)
	FileInstall("TWX\scripts\include\NearFig.ts", $twxincludefolder & "\NearFig.ts", 1)
	FileInstall("TWX\scripts\include\PlanetCheck.ts", $twxincludefolder & "\PlanetCheck.ts", 1)
	FileInstall("TWX\scripts\include\PlanetInfo.ts", $twxincludefolder & "\PlanetInfo.ts", 1)
	FileInstall("TWX\scripts\include\PlanetLoop.ts", $twxincludefolder & "\PlanetLoop.ts", 1)
	FileInstall("TWX\scripts\include\PlanetUpgrade.ts", $twxincludefolder & "\PlanetUpgrade.ts", 1)
	FileInstall("TWX\scripts\include\PlayerInfo.ts", $twxincludefolder & "\PlayerInfo.ts", 1)
	FileInstall("TWX\scripts\include\PortCheck.ts", $twxincludefolder & "\PortCheck.ts", 1)
	FileInstall("TWX\scripts\include\PPT.ts", $twxincludefolder & "\PPT.ts", 1)
	FileInstall("TWX\scripts\include\Probe.ts", $twxincludefolder & "\Probe.ts", 1)
	FileInstall("TWX\scripts\include\Refurb.ts", $twxincludefolder & "\Refurb.ts", 1)
	FileInstall("TWX\scripts\include\Rob.ts", $twxincludefolder & "\Rob.ts", 1)
	FileInstall("TWX\scripts\include\Routes.ts", $twxincludefolder & "\Routes.ts", 1)
	FileInstall("TWX\scripts\include\SDF.ts", $twxincludefolder & "\SDF.ts", 1)
	FileInstall("TWX\scripts\include\SDT.ts", $twxincludefolder & "\SDT.ts", 1)
	FileInstall("TWX\scripts\include\SeekProduct.ts", $twxincludefolder & "\SeekProduct.ts", 1)
	FileInstall("TWX\scripts\include\SeekTarget.ts", $twxincludefolder & "\SeekTarget.ts", 1)
	FileInstall("TWX\scripts\include\SellSteal.ts", $twxincludefolder & "\SellSteal.ts", 1)
	FileInstall("TWX\scripts\include\ShipStats.ts", $twxincludefolder & "\ShipStats.ts", 1)
	FileInstall("TWX\scripts\include\SSF.ts", $twxincludefolder & "\SSF.ts", 1)
	FileInstall("TWX\scripts\include\SSM.ts", $twxincludefolder & "\SSM.ts", 1)
	FileInstall("TWX\scripts\include\SST.ts", $twxincludefolder & "\SST.ts", 1)
	FileInstall("TWX\scripts\include\SSTScout.ts", $twxincludefolder & "\SSTScout.ts", 1)
	FileInstall("TWX\scripts\include\StealDump.ts", $twxincludefolder & "\StealDump.ts", 1)
	FileInstall("TWX\scripts\include\StripCorp.ts", $twxincludefolder & "\StripCorp.ts", 1)
	FileInstall("TWX\scripts\include\StripRank.ts", $twxincludefolder & "\StripRank.ts", 1)
	FileInstall("TWX\scripts\include\TestSector.ts", $twxincludefolder & "\TestSector.ts", 1)
	FileInstall("TWX\scripts\include\Warp.ts", $twxincludefolder & "\Warp.ts", 1)
	FileInstall("TWX\scripts\include\WorldSSM.ts", $twxincludefolder & "\WorldSSM.ts", 1)
	FileInstall("TWX\scripts\include\WorldSST.ts", $twxincludefolder & "\WorldSST.ts", 1)
	FileInstall("TWX\scripts\include\WorldTrade.ts", $twxincludefolder & "\WorldTrade.ts", 1)

EndFunc

Func CreateDesktopShortCut()
	If $deploytwx = True Then
		FileCreateShortcut ($twxrootfolder & "\TWXProxy.exe", @DesktopDir & "\TWXProxy.lnk" , $twxrootfolder, "" , "TWX Proxy")
	EndIf
	If $deployputty = True Then
		FileCreateShortcut ($puttyfolder & "\putty.exe", @DesktopDir & "\Putty.lnk" , $puttyfolder, "" , "Putty")
	EndIf
	If $deployzbot = True Then
		FileCreateShortcut ($twxrootfolder & "\ClearTWX.cmd", @DesktopDir & "\ClearTWX.lnk" , $twxrootfolder, "" , "ClearTWX")
		FileCreateShortcut ($twxrootfolder & "\ClearTWXBackups.cmd", @DesktopDir & "\ClearTWXBackups.lnk" , $twxrootfolder, "" , "ClearTWXBackups")
	EndIf
EndFunc

Func CreateStartMenuShortCut()
	$startmenudir = @StartMenuDir & "\TWX Proxy"
	If DirGetSize($startmenudir) = -1 Then
		DirCreate($startmenudir)
	EndIf
	If $deploytwx = True Then
		FileCreateShortcut ($twxrootfolder & "\TWXProxy.exe", $startmenudir & "\TWXProxy.lnk" , $twxrootfolder, "" , "TWX Proxy")
		FileCreateShortcut ($twxrootfolder & "\pack2.html", $startmenudir & "\Pack2Reference.lnk" , $twxrootfolder, "" , "TWX Pack 2 Scripts")
		FileCreateShortcut ($twxrootfolder & "\scripts.html", $startmenudir & "\ScriptReference.lnk" , $twxrootfolder, "" , "TWX Language Reference")
	EndIf
	If $deployputty = True Then
		FileCreateShortcut ( $puttyfolder & "\putty.exe", $startmenudir & "\Putty.lnk" , $puttyfolder, "" , "Putty Telnet Client")
		FileCreateShortcut ( $puttyfolder & "\puttydoc.txt", $startmenudir & "\PuttyDoc.lnk" , $puttyfolder, "" , "Putty Docs")
	EndIf
	If $deployzbot = True Then
		FileCreateShortcut ($twxrootfolder & "\ClearTWX.cmd", $startmenudir & "\ClearTWX.lnk" , $twxrootfolder, "" , "ClearTWX")
		FileCreateShortcut ($twxrootfolder & "\ClearTWXBackups.cmd", $startmenudir & "\ClearTWXBackups.lnk" , $twxrootfolder, "" , "ClearTWXBackups")
	EndIf
EndFunc

Func QuitEarly()
	$answer = False
	If (MsgBox(4, "Cancel Installation", "No changes have been made." & @CRLF & "Are you sure you want to abort the installation?") = 6) Then
		$answer = True
	EndIf
	Return $answer
EndFunc
