# Title: Z-Limps
# Author: Zed
# Copyright (c) 2010 by Archibald H. Vilanos III
# All Rights Reserved.
# Refreshes the LIMPSEC Sector Parameter in the TWX Database.
SetVar $version "1.05"
SetVar $scriptname "Z-Limps"
SetVar $scripttitle "Zed's Limpet Mine Refresh"
SetVar $Z_Lib~scriptname $scriptname
SetVar $Z_Lib~scripttitle $scripttitle
SetVar $Z_Lib~Version $version
GoSub :Z_Lib~INITLIB
Gosub :Z_Lib~CHECKONCE
Gosub :Z_Lib~CURRENTPLANET
SetVar $Z_Lib~setprompt "COMMAND"
Gosub :Z_Lib~PROMPT
Gosub :Z_Lib~COMMSOFF
LoadVar $z_lastlimprefresh
If ($z_lastlimprefresh = "0")
   SetVar $z_lastlimprefresh "None"
End
GetSectorParameter 2 "LIMP_COUNT" $z_lastlimpcount
If ($z_lastlimpcount = "")
   SetVar $z_lastlimpcount "0"
End
SetVar $z_limpcount "0"
SetVar $Z_Lib~extra ANSI_10 & "- Counting Current Limps In Database..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $current "0"
SetVar $count "1"
While ($count <= SECTORS)
    GetSectorParameter $count "LIMPSEC" $islimped
    If ($islimped = TRUE)
       SetVar $current ($current + 1)
    End
    SetVar $count ($count + 1)
End
SetVar $Z_Lib~extra ANSI_10 & "- Clearing Database..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $count "1"
While ($count <= SECTORS)
    SetSectorParameter $count "LIMPSEC" FALSE
    SetVar $count ($count + 1)
End
SetVar $Z_Lib~extra ANSI_10 & "- Refreshing Limpets..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $trigger2u "Deployed  Limpet  Scan"
:MONITOR
Gosub :Z_Lib~ANSI_OFF
SetTextLineTrigger 2u :LIMPS $trigger2u
Send "k2"
Pause
:LIMPS
KillAllTriggers
SetTextLineTrigger limpscan1 :STARTLIMPSCAN "===================="
SetTextLineTrigger limpnone :ENDLIMPSCAN "No Limpet mines deployed"
SetTextLineTrigger limpscan2 :ENDLIMPSCAN "Total"
Pause
:STARTLIMPSCAN
KillAllTriggers
SetTextLineTrigger limpscan3 :SCANLINE
Pause
:SCANLINE
KillAllTriggers
SetVar $line CURRENTLINE
GetWordPos $line $pos "Total"
GetWordPos $line $pos2 "No Limpet mines deployed"
If ($pos > 0)
	GetWord $line $z_deployed 1
	ReplaceText $z_deployed "T" ",000"
	ReplaceText $z_deployed "M" ",000,000"
	Goto :ENDLIMPSCAN
ElseIf ($pos2 > 0)
   Goto :ENDLIMPSCAN
Else
   GetWord $line $sectnum 1
   IsNumber $isnum $sectnum
   If ($isnum = TRUE)
      SetSectorParameter $sectnum "LIMPSEC" TRUE
      SetVar $z_limpcount ($z_limpcount + 1)
   End
End
Goto :STARTLIMPSCAN
:ENDLIMPSCAN
KillAllTriggers
Gosub :Z_Lib~ANSI_ON
Waitfor "] (?=Help)? :"
SetPrecision 2
If ($z_lastlimpcount > 0)
   SetVar $z_lastpercent (($z_lastlimpcount * 100) / SECTORS)
Else
   SetVar $z_lastpercent "0"
End
If ($z_limpcount > 0)
   SetVar $z_grid (($z_limpcount * 100) / SECTORS)
Else
   SetVar $z_grid "0.00"
End
SetPrecision 0
SetVar $z_diff ($z_limpcount - $z_lastlimpcount)
SetPrecision 2
If ($z_diff <> 0)
   Setvar $z_diffperc (($z_diff * 100) / SECTORS)
Else
   Setvar $z_diffperc "0.00"
End
SetPrecision 0
Gosub :Z_Lib~RETURNTOPLANET
Gosub :Z_Lib~SYNC
Send "'*"
Send "---------------------------------------------------------------------*"
Send "Zed's Limpet Mine Refresh v" & $Version & "*"
Send "-------------------------------*"
Send "Database Check : " & $current & "*"
Send "-*"
Send "Last Refresh   : " & $z_lastlimprefresh & "*"
Send "Last Count     : " & $z_lastlimpcount & "*"
Send "Last Percent   : " & $z_lastpercent & "%*"
Send "-*"
Send "Current Count  : " & $z_limpcount & "*"
Send "Current Limp%  : " & $z_grid & "%*"
Send "-*"
Send "Difference     : " & $z_diff & "*"
Send "Percentage     : " & $z_diffperc & "%*"
Send "-*"
Send "Total Deployed : " & $z_deployed & "*"
Send "---------------------------------------------------------------------**"
Waitfor "Sub-space comm-link terminated"
SetVar $Z_Lib~extra ANSI_10 & "- Done !"
Gosub :Z_Lib~HEADER
Echo  "*"
Echo ANSI_10 & "Database Check : " & ANSI_3 & $current & "*"
Echo "*"
Echo ANSI_10 & "Last Refresh   : " & ANSI_7 & $z_lastlimprefresh & "*"
Echo ANSI_10 & "Last Count     : " & ANSI_7 & $z_lastlimpcount & "*"
Echo ANSI_10 & "Last Percent   : " & ANSI_7 & $z_lastpercent & "%*"
Echo  "*"
Echo ANSI_10 & "Current Count  : " & ANSI_15 & $z_limpcount & "*"
Echo ANSI_10 & "Current Limp%  : " & ANSI_15 & $z_grid & "%*"
Echo  "*"
Echo ANSI_10 & "Difference     : " & ANSI_14 & $z_diff & "*"
Echo ANSI_10 & "Percentage     : " & ANSI_14 & $z_diffperc & "%*"
Echo "*"
Echo ANSI_10 & "Total Deployed : " & ANSI_7 & $z_deployed & "*"
Gosub :Z_Lib~REDLINE
Echo  "*"
SetSectorParameter 2 "LIMP_COUNT" $z_limpcount
SetVar $z_lastlimprefresh (DATE & " - " & TIME)
SaveVar $z_lastlimprefresh
Goto :FINISH
:FINISH
Gosub :Z_Lib~COMMSON
Halt
# Includes
Include include\Z_Lib.ts
# ZeD Compiled: Tue 07/06/2011 -  6:00:10.22 
# ZeD Compiled: Wed 22/06/2011 - 16:45:06.62 
