# Title: Z-Mines
# Author: Zed
# Copyright (c) 2010 by Archibald H. Vilanos III
# All Rights Reserved.
# Refreshes the MINESEC Sector Parameter in the TWX Database.
SetVar $version "1.05"
SetVar $scriptname "Z-Mines"
SetVar $scripttitle "Zed's Armid Mine Refresh"
SetVar $tagline "*" & ANSI_12 &"-=["& ANSI_14 & $scripttitle & " v"& $version & ANSI_12 &"]=-"
SetVar $Z_Lib~scriptname $scriptname
SetVar $Z_Lib~scripttitle $scripttitle
SetVar $Z_Lib~Version $version
GoSub :Z_Lib~INITLIB
Gosub :Z_Lib~CHECKONCE
Gosub :Z_Lib~CURRENTPLANET
SetVar $Z_Lib~setprompt "COMMAND"
Gosub :Z_Lib~PROMPT
Gosub :Z_Lib~COMMSOFF
LoadVar $z_lastminerefresh
If ($z_lastminerefresh = "0")
   SetVar $z_lastminerefresh "None"
End
GetSectorParameter 2 "MINE_COUNT" $z_lastminecount
If ($z_lastminecount = "")
   SetVar $z_lastminecount "0"
End
SetVar $z_minecount "0"
SetVar $Z_Lib~extra ANSI_10 & "- Counting Current Mines In Database..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $current "0"
SetVar $count "1"
While ($count <= SECTORS)
    GetSectorParameter $count "MINESEC" $ismined
    If ($ismined = TRUE)
       SetVar $current ($current + 1)
    End
    SetVar $count ($count + 1)
End
SetVar $Z_Lib~extra ANSI_10 & "- Clearing Database..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $count "1"
While ($count <= SECTORS)
    SetSectorParameter $count "MINESEC" FALSE
    SetVar $count ($count + 1)
End
SetVar $Z_Lib~extra ANSI_10 & "- Refreshing Mines..."
Gosub :Z_Lib~HEADER
Echo  "*"
SetVar $trigger2u "Deployed  Mine  Scan"
:MONITOR
Gosub :Z_Lib~ANSI_OFF
SetTextLineTrigger 2u :MINES $trigger2u
Send "k1"
Pause
:MINES
KillAllTriggers
SetTextLineTrigger minescan1 :STARTMINESCAN "===================="
SetTextLineTrigger minenone :ENDMINESCAN "No mines deployed"
SetTextLineTrigger minescan2 :ENDMINESCAN "Total"
Pause
:STARTMINESCAN
KillAllTriggers
SetTextLineTrigger minescan3 :SCANLINE
Pause
:SCANLINE
KillAllTriggers
SetVar $line CURRENTLINE
GetWordPos $line $pos "Total"
GetWordPos $line $pos2 "No mines deployed"
If ($pos > 0)
	GetWord $line $z_deployed 1
	ReplaceText $z_deployed "T" ",000"
	ReplaceText $z_deployed "M" ",000,000"
	Goto :ENDMINESCAN
ElseIf ($pos2 > 0)
   Goto :ENDMINESCAN
Else
   GetWord $line $sectnum 1
   IsNumber $isnum $sectnum
   If ($isnum = TRUE)
      SetSectorParameter $sectnum "MINESEC" TRUE
      SetVar $z_minecount ($z_minecount + 1)
   End
End
Goto :STARTMINESCAN
:ENDMINESCAN
KillAllTriggers
Gosub :Z_Lib~ANSI_ON
Waitfor "] (?=Help)? :"
SetPrecision 2
If ($z_lastminecount > 0)
   SetVar $z_lastpercent (($z_lastminecount * 100) / SECTORS)
Else
   SetVar $z_lastpercent "0"
End
If ($z_minecount > 0)
   SetVar $z_grid (($z_minecount * 100) / SECTORS)
Else
   SetVar $z_grid "0.00"
End
SetPrecision 0
SetVar $z_diff ($z_minecount - $z_lastminecount)
SetPrecision 2
If ($z_diff <> 0)
   Setvar $z_diffperc (($z_diff * 100) / SECTORS)
Else
   Setvar $z_diffperc "0.00"
End
SetPrecision 0
Gosub :Z_Lib~RETURNTOPLANET
Gosub :Z_Lib~SYNC
Send "'*"
Send "---------------------------------------------------------------------*"
Send "Zed's Mine Refresh v" & $Version & "*"
Send "------------------------*"
Send "Database Check : " & $current & "*"
Send "-*"
Send "Last Refresh   : " & $z_lastminerefresh & "*"
Send "Last Count     : " & $z_lastminecount & "*"
Send "Last Percent   : " & $z_lastpercent & "%*"
Send "-*"
Send "Current Count  : " & $z_minecount & "*"
Send "Current Mine%  : " & $z_grid & "%*"
Send "-*"
Send "Difference     : " & $z_diff & "*"
Send "Percentage     : " & $z_diffperc & "%*"
Send "-*"
Send "Total Deployed : " & $z_deployed & "*"
Send "---------------------------------------------------------------------**"
Waitfor "Sub-space comm-link terminated"
SetVar $Z_Lib~extra ANSI_10 & "- Done !"
Gosub :Z_Lib~HEADER
Echo  "*"
Echo ANSI_10 & "Database Check : " & ANSI_3 & $current & "*"
Echo "*"
Echo ANSI_10 & "Last Refresh   : " & ANSI_7 & $z_lastminerefresh & "*"
Echo ANSI_10 & "Last Count     : " & ANSI_7 & $z_lastminecount & "*"
Echo ANSI_10 & "Last Percent   : " & ANSI_7 & $z_lastpercent & "%*"
Echo  "*"
Echo ANSI_10 & "Current Count  : " & ANSI_15 & $z_minecount & "*"
Echo ANSI_10 & "Current Mine%  : " & ANSI_15 & $z_grid & "%*"
Echo  "*"
Echo ANSI_10 & "Difference     : " & ANSI_14 & $z_diff & "*"
Echo ANSI_10 & "Percentage     : " & ANSI_14 & $z_diffperc & "%*"
Echo "*"
Echo ANSI_10 & "Total Deployed : " & ANSI_7 & $z_deployed & "*"
Gosub :Z_Lib~REDLINE
Echo  "*"
SetSectorParameter 2 "MINE_COUNT" $z_minecount
SetVar $z_lastminerefresh (DATE & " - " & TIME)
SaveVar $z_lastminerefresh
Goto :FINISH
:FINISH
Gosub :Z_Lib~COMMSON
Halt
# Includes
Include include\Z_Lib.ts
# ZeD Compiled: Tue 07/06/2011 -  6:00:04.40 
# ZeD Compiled: Wed 22/06/2011 - 16:45:11.10 
