# Copyright (C) 2005  Remco Mulder
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# For source notes please refer to Notes.txt
# For license terms please refer to GPL.txt.
# 
# These files should be stored in the root of the compression you 
# received this source in.

LoadVar $PARM1

If ($parm1 = "?")
	LoadVar $command
	LoadVar $z_botname
	Send "'* 2_WorldTrade - Edited by Archy.*"
	Send " --------------------------------* *"
	Send " Usage: " & "'" & $z_botname & " " & $command & " {OPTIONS}*"
	Send " *"
	Send " Available options:*"
	Send " -------------------* *"
	Send " X%  - Where X is the percentage of product to trade down to.*"
	Send "       Default is 20% - This must be the first parameter if used.*"
	Send " *"
	Send " HAGGLE - Turns on haggling. Default is OFF.*"
	Send " *"
	Send " ALWAYS - Sets HoloScanning to ALWAYS. Default is Standard.*"
	Send " NEVER  - Sets HoloScanning to NEVER. Default is Standard.*"
	Send " *"
	Send " PARANOID - Sets Evasion to PARANOID. Default is Standard.*"
	Send " RECKLESS - Sets Evasion to RECKLESS. Default is Standard.*"
	Send " *"
	Send " [EXTRASEND] - Place the ExtraSend code between square brackets.*"
	Send "               the default is f1" & #42 & "cd*"
	Send " *"
	Send " Note: Options and defaults are only set if OPTIONS are specified.*"
	Send "       If ANY option is specified, ALL defaults are applied.*"
	Send "       Otherwise the values are left at their previous settings.*"
	Send "*"
	Halt
End

setVar $Header~Script "World Trade"

# check location
Send #145
WaitOn #145 & #8
cutText CURRENTLINE $location 1 7
If ($location <> "Command")
	Send "z s * q q q q z 0* q z 0* q z 0* "
	Send #145
	WaitOn #145 & #8
	cutText CURRENTLINE $location 1 7
End
if ($location <> "Command")
	clientMessage "This script must be run from the command prompt."
	Echo "***" & ANSI_14 & "Current Prompt: " & ANSI_15 & $location & "***" & ANSI_0
	halt
end
reqRecording
logging off
gosub :Header~Pack2Header

# get defaults
loadVar $WorldTradeSaved

if ($WorldTradeSaved)
  loadVar $Haggle~HaggleFactor
else
  setVar $Haggle~HaggleFactor 7
  saveVar $Haggle~HaggleFactor
  
  setVar $WorldTradeSaved 1
  saveVar $WorldTradeSaved
end

# create setup menu
#addMenu "" "WorldTrade" "World Trade Settings" "." "" "Main" FALSE
#addMenu "WorldTrade" "GO" "GO!" "G" :Menu_Go "" TRUE

# set move routine prefs
loadVar $Move~Saved

if ($Move~Saved)
  loadVar $Move~ScanHolo
  loadVar $Move~Evasion
  loadVar $Move~Attack
  loadVar $Move~PortPriority
  loadVar $Move~ExtraSend
  replaceText $Move~ExtraSend #42 "*"
else
  setVar $Move~ScanHolo 1
  setVar $Move~Evasion 0
  setVar $Move~Attack 0
  setVar $Move~PortPriority 1
  setVar $Move~ExtraSend "f1" & #42 & "cd"
  saveVar $Move~ExtraSend
  replaceText $Move~ExtraSend #42 "*"
  
  saveVar $Move~ScanHolo
  saveVar $Move~Evasion
  saveVar $Move~Attack
  saveVar $Move~PortPriority
  
  setVar $Move~Saved 1
  saveVar $Move~Saved
end
#SetVar $Move~$ExtraSend "f1*cd"
#setVar $Move~Menu "WorldTrade"
#gosub :Move~Menu
#setMenuHelp "Move" "This menu lets you configure how the script will navigate the game, searching for port pairs."

# set PPT prefs
loadVar $PPT~Saved

if ($PPT~Saved)
  loadVar $PPT~DropFigs
  loadVar $PPT~PercTrade
else
  setVar $PPT~DropFigs 1
  setVar $PPT~PercTrade 20
  
  saveVar $PPT~DropFigs
  saveVar $PPT~PercTrade
  
  setVar $PPT~Saved 1
  saveVar $PPT~Saved
end

#setVar $PPT~Menu "WorldTrade"
#gosub :PPT~Menu

# set PPTCheck prefs
loadVar $PortCheck~Saved

if ($PortCheck~Saved)
  loadVar $PortCheck~Danger
  loadVar $PortCheck~FuelOrganics
  loadVar $PortCheck~PortType    
else
  setVar $PortCheck~Danger 0
  setVar $PortCheck~FuelOrganics 1
  setVar $PortCheck~PortType 1
  
  saveVar $PortCheck~Danger
  saveVar $PortCheck~FuelOrganics
  saveVar $PortCheck~PortType
  
  setVar $PortCheck~Saved 1
  saveVar $PortCheck~Saved
end

#gosub :PortCheck~Menu
#setMenuHelp "PPT" "This menu lets you configure how the script performs its port-pair-trading."

# open config menu
#openMenu "WorldTrade"


If ($PARM1 <> "0")
	LoadVar $user_command_line
	SetVar $Move~$ExtraSend "f1*cd"
	GetText $user_command_line $temp "[" "]"
	If ($temp <> "")
		SetVar $Move~$ExtraSend $temp
		replaceText $Move~ExtraSend #42 "*"
		SaveVar $Move~$ExtraSend
		StripText $user_command_line "[" & $temp & "]"
	End
	LowerCase $user_command_line
	GetWordPos $user_command_line $pos "haggle"
	If ($pos <> "0")
		setVar $Haggle~HaggleFactor 7
	Else
		setVar $Haggle~HaggleFactor 0
	End
	saveVar $Haggle~HaggleFactor
	saveVar $WorldTradeSaved
	
	setVar $Move~ScanHolo 1
	GetWordPos $user_command_line $pos "always"
	If ($pos <> "0")
		setVar $Move~ScanHolo 2
	End
	GetWordPos $user_command_line $pos "never"
	If ($pos <> "0")
		setVar $Move~ScanHolo 0
	End
	saveVar $Move~ScanHolo
	
	setVar $Move~Evasion 0
	GetWordPos $user_command_line $pos "paranoid"
	If ($pos <> "0")
		setVar $Move~Evasion 1
	End
	GetWordPos $user_command_line $pos "reckless"
	If ($pos <> "0")
		setVar $Move~Evasion 2
	End
	saveVar $Move~Evasion
	
	setVar $PPT~PercTrade 20
	GetWordPos $PARM1 $pos "%"
	If ($pos <> "0")
		StripText $PARM1 "%"
		setVar $PPT~PercTrade $PARM1
		saveVar $PPT~PercTrade
	End
End





:Menu_Go
setVar $WorldTrade~Quota 0
setEventTrigger disconnect :disconnected "Connection lost"
gosub :WorldTrade~WorldTrade
halt

:disconnected
  # disconnected.  Wait for the prompt then restart
  killAllTriggers
  
  waitFor "Command [TL="
  goto :Menu_Go
  

# includes:
include "include\header"
include "include\worldTrade"
# ZeD Compiled: Sun 30/01/2011 -  5:46:55.55 
# ZeD Compiled: Thu 29/11/2012 - 12:21:21.21 
# ZeD Compiled: Wed 31/07/2013 - 12:52:37.61 
# ZeD Compiled: Tue 10/09/2013 - 15:18:28.59 
# ZeD Compiled: Thu 12/09/2013 - 21:18:18.47 
# ZeD Compiled: Wed 13/11/2013 - 20:23:08.11 
# ZeD Compiled: Mon 18/11/2013 - 19:28:23.89 
