# ----- SCRIPT NAME AND VERSION -----
# Edited by Archy. 
setVar $scriptname "CK Buydown"
SetVar $originalversion "3.02"
setVar $version "3.0.2z"
ECHO "**----- " & $scriptname & " v. " & $version & " -----**"

setVar $overhagglemultiple 147
setVar $cyclebuffer 1
setVar $cyclebufferlimit 20
setVar $output ""

# CREDITS
# -------
# Written by Cherokee

# ----- INCLUDES -----
include "_ckinc_getInfo.ts"
include "_ckinc_getPlanetInfo.ts"
include "_ckinc_CNsettings.ts"
include "_ckinc_swathoff.ts"
include "_ckinc_voidadjacent.ts"



# KNOWN ISSUES
# ------------
# None


# REVISION HISTORY
# ----------------
# 1.0.0 First working version
# 1.1.0 Sets avoids on adjacent sectors, detects swath auto haggle
# 1.2.0 works from planet prompt
# 1.2.1 takes into account planet maximums
# 3.0.0 revamped to allow for loading from other scripts


# SCRIPT REQUIREMENTS
# -------------------
#
# - COMPUTER SETTINGS
#   (1) ANSI graphics            - On (required)
#   (2) Animation display        - Off (not required, but recommended for speed)
#   (3) Page on messages         - Off (required)
#   (9) Abort display on keys    - SPACE (required)
#   (A) Message Display Mode     - Compact (required)


# ----- make sure we are at a good prompt -----
:verifyprompt
    cutText CURRENTLINE $location 1 7
    stripText $location " "
    if (($location <> "Citadel") and ($location <> "Planet"))
        setVar $exit_message "Must start at Planet or Citadel Prompt for Buydown"
        goto :exit
    end

if ($location = "Citadel")
    send "Q"
end
send "tnl1*tnl2*tnl3*snl1*"
waitfor "How many groups of Colonists do you want to leave"
gosub :_ckinc_getPlanetInfo~getPlanetinfo

if ($location = "Citadel")
    send "Cs*"
else
    send "QD"
end

gosub :_ckinc_CNsettings~startCNsettings
gosub :_ckinc_getInfo~getinfo
if ($_ckinc_getInfo~holds <> $_ckinc_getInfo~emptyholds)
    gosub :_ckinc_CNsettings~endCNsettings
    if ($location <> "Citadel")
        send "L " & $_ckinc_getPlanetInfo~planet & "* "
    end
    setVar $exit_message "Planet full, cannot empty ship holds"
    goto :exit
end
gosub :_ckinc_voidAdjacent~voidAdjacent
gosub :getPortInfo

if ($location = "Citadel")
    send "Q"
else
    send "L " & $_ckinc_getPlanetInfo~planet & "* "
end

setDelayTrigger initpause :initpause 500
pause
:initpause


loadvar $_ck_buydown_fuelrounds
loadvar $_ck_buydown_orgrounds
loadvar $_ck_buydown_equiprounds
loadvar $_ck_buydown_mode
# added by archy ----
LoadVar $z_minturns
#--------------------
:getinputs
    setVar $turns_needed 0
    setVar $turns_allowed ($_ckinc_getInfo~turns - $z_minturns)
    subtract $turns_allowed 1



    # --- calculate how much fuel we can buy
    setVar $fuelrounds 0
    setVar $planetfuelroom $_ckinc_getPlanetInfo~planetfuelmax
    subtract $planetfuelroom $_ckinc_getPlanetInfo~planetfuel
    setVar $maxfueltobuy $fuelselling
    if ($fuelselling > $planetfuelroom)
        setVar $maxfueltobuy $planetfuelroom
    end
    setVar $maxfuelrounds $maxfueltobuy
    divide $maxfuelrounds $_ckinc_getInfo~holds
	# added by archy ---------------------------
	SetVar $maxfuelrounds ($maxfuelrounds - 1)
	If ($maxfuelrounds < 0)
		SetVar $maxfuelrounds 0
	End
	#-------------------------------------------
    if ($maxfuelrounds > $turns_allowed)
        setVar $maxfuelrounds $turns_allowed
    end
    if ($maxfuelrounds > 0)
        if (($_ck_buydown_fuelrounds = 0) or ($_ck_buydown_fuelrounds = "DELETED"))
            setVar $prompt "How many rounds of fuel? (max " & $maxfuelrounds & ")"
            getInput $fuelrounds $prompt 0
        elseif ($_ck_buydown_fuelrounds = "-1")
            setVar $fuelrounds 0
        elseif ($_ck_buydown_fuelrounds = "max")
            setVar $fuelrounds $maxfuelrounds
        else
            isNumber $isnum $_ck_buydown_fuelrounds
            if ($isnum)
                setVar $fuelrounds $_ck_buydown_fuelrounds
            else
                if ($location = "Citadel")
                    send "C "
                end
                setVar $exit_message "Invalid parameter passed from control script"
                goto :exit
            end
        end
    end

    if ($fuelrounds > $maxfuelrounds)
        setVar $fuelrounds $maxfuelrounds
    end

    if ($fuelrounds < 0)
        send "'Invalid Entry, please try again*"
        goto :getinputs
    end

    add $turns_needed $fuelrounds
    subtract $turns_allowed $fuelrounds






    # --- calculate how much org we can buy
    setVar $orgrounds 0
    setVar $planetorgroom $_ckinc_getPlanetInfo~planetorgmax
    subtract $planetorgroom $_ckinc_getPlanetInfo~planetorg
    setVar $maxorgtobuy $orgselling
    if ($orgselling > $planetorgroom)
        setVar $maxorgtobuy $planetorgroom
    end
    setVar $maxorgrounds $maxorgtobuy
    divide $maxorgrounds $_ckinc_getInfo~holds
	# added by archy ---------------------------
	SetVar $maxorgrounds ($maxorgrounds - 1)
	If ($maxorgrounds < 0)
		SetVar $maxorgrounds 0
	End
	#-------------------------------------------
    if ($maxorgrounds > $turns_allowed)
        setVar $maxorgrounds $turns_allowed
    end
    if ($maxorgrounds > 0)
        if (($_ck_buydown_orgrounds = 0) or ($_ck_buydown_orgrounds = "DELETED"))
            setVar $prompt "How many rounds of org? (max " & $maxorgrounds & ")"
            getInput $orgrounds $prompt 0
        elseif ($_ck_buydown_orgrounds = "-1")
            setVar $orgrounds 0
        elseif ($_ck_buydown_orgrounds = "max")
            setVar $orgrounds $maxorgrounds
        else
            isNumber $isnum $_ck_buydown_orgrounds
            if ($isnum)
                setVar $orgrounds $_ck_buydown_orgrounds
            else
                if ($location = "Citadel")
                    send "C "
                end
                setVar $exit_message "Invalid parameter passed from control script"
                goto :exit
            end
        end
    end

    if ($orgrounds > $maxorgrounds)
        setVar $orgrounds $maxorgrounds
    end

    if ($orgrounds < 0)
        send "'Invalid Entry, please try again*"
        goto :getinputs
    end

    add $turns_needed $orgrounds
    subtract $turns_allowed $orgrounds






    # --- calculate how much equip we can buy
    setVar $equiprounds 0
    setVar $planetequiproom $_ckinc_getPlanetInfo~planetequipmax
    subtract $planetequiproom $_ckinc_getPlanetInfo~planetequip
    setVar $maxequiptobuy $equipselling
    if ($equipselling > $planetequiproom)
        setVar $maxequiptobuy $planetequiproom
    end
    setVar $maxequiprounds $maxequiptobuy
    divide $maxequiprounds $_ckinc_getInfo~holds
	# added by archy ---------------------------
	SetVar $maxequiprounds ($maxequiprounds - 1)
	If ($maxequiprounds < 0)
		SetVar $maxequiprounds 0
	End
	#-------------------------------------------
    if ($maxequiprounds > $turns_allowed)
        setVar $maxequiprounds $turns_allowed
    end
    if ($maxequiprounds > 0)
        if (($_ck_buydown_equiprounds = 0) or ($_ck_buydown_equiprounds = "DELETED"))
            setVar $prompt "How many rounds of equip? (max " & $maxequiprounds & ")"
            getInput $equiprounds $prompt 0
        elseif ($_ck_buydown_equiprounds = "-1")
            setVar $equiprounds 0
        elseif ($_ck_buydown_equiprounds = "max")
            setVar $equiprounds $maxequiprounds
        else
            isNumber $isnum $_ck_buydown_equiprounds
            if ($isnum)
                setVar $equiprounds $_ck_buydown_equiprounds
            else
                if ($location = "Citadel")
                    send "C "
                end
                setVar $exit_message "Invalid parameter passed from control script"
                goto :exit
            end
        end
    end

    if ($equiprounds > $maxequiprounds)
        setVar $equiprounds $maxequiprounds
    end

    if ($equiprounds < 0)
        send "'Invalid Entry, please try again*"
        goto :getinputs
    end

    add $turns_needed $equiprounds
    subtract $turns_allowed $equiprounds







    if (($fuelrounds = 0) and ($orgrounds = 0) and ($equiprounds = 0))
        if ($location = "Citadel")
            send "C "
        end
        setVar $exit_message "Nothing to buy"
        goto :exit
    end



    :getMode
    if ($_ck_buydown_mode = "s")
        setVar $buydown_mode 1
    elseif ($_ck_buydown_mode = "b")
        setVar $buydown_mode 2
    elseif ($_ck_buydown_mode = "w")
        setVar $buydown_mode 3
    else
        echo "*Haggle Method? (  1=Speedbuy  -  2=Best Price  -  3=Worst Price  )*"
        getConsoleInput $buydown_mode 0
        if (($buydown_mode <> 1) AND ($buydown_mode <> 2) AND ($buydown_mode <> 3))
            echo "**Invalid Buydown Mode**"
            goto :getMode
        end
    end


    if ($buydown_mode = 1)
        setVar $buydown_mode "Speedbuy"
    elseif ($buydown_mode = 2)
        setVar $buydown_mode "Best Price"
    elseif ($buydown_mode = 3)
        setVar $buydown_mode "Worst Price"
    end

    echo "**"
    echo "Buying down using " & $buydown_mode & "*"
    echo $fuelrounds & " rounds of fuel*"
    echo $orgrounds & " rounds of org*"
    echo $equiprounds & " rounds of equip*"
    echo "Using " & $turns_needed & " turns*"
    echo "*You have 3 seconds to press $ to abort this buydown.*"
    setDelayTrigger abortchance :abortchance 3000
    pause

    :abortchance


    send "'*" & $scriptname & " v. " & $version & " - buying down using " & $buydown_mode & "*"
    send $fuelrounds & " rounds of fuel*"
    send $orgrounds & " rounds of org*"
    send $equiprounds & " rounds of equip*"
    send "*"

    setVar $fuelroundsleft $fuelrounds
    setVar $orgroundsleft $orgrounds
    setVar $equiproundsleft $equiprounds


# determine how much this will all cost, and get credits from citadel if needed
if ($fuelrounds > 0)
    setVar $fuel_creds_needed $fuelrounds
    multiply $fuel_creds_needed $_ckinc_getInfo~holds
    multiply $fuel_creds_needed 30
    if ($buydown_mode = "Worst Price")
        multiply $fuel_creds_needed 3
        divide $fuel_creds_needed 2
    end
end
if ($orgrounds > 0)
    setVar $org_creds_needed $orgrounds
    multiply $org_creds_needed $_ckinc_getInfo~holds
    multiply $org_creds_needed 60
    if ($buydown_mode = "Worst Price")
        multiply $org_creds_needed 3
        divide $org_creds_needed 2
    end
end
if ($equiprounds > 0)
    setVar $equip_creds_needed $equiprounds
    multiply $equip_creds_needed $_ckinc_getInfo~holds
    multiply $equip_creds_needed 100
    if ($buydown_mode = "Worst Price")
        multiply $equip_creds_needed 3
        divide $equip_creds_needed 2
    end
end
setVar $total_creds_needed 0
add $total_creds_needed $fuel_creds_needed
add $total_creds_needed $org_creds_needed
add $total_creds_needed $equip_creds_needed

if ($total_creds_needed > $_ckinc_getInfo~credits)
    setVar $cashonhand $_ckinc_getPlanetInfo~citadelcredits
    add $cashonhand $_ckinc_getInfo~credits
    if ($cashonhand > $total_creds_needed)
        send "C"
        send "TT" & $_ckinc_getInfo~credits & "*"
        send "TF" & $total_creds_needed & "*"
        setVar $_ckinc_getInfo~credits $total_creds_needed
        send "'Withdrew funds from the Treasury to complete the buydown*"
        send "Q"
    else
        if ($location = "Citadel")
            send "C "
        end
        setVar $exit_message "Not enough cash onhand"
        goto :exit
    end
end

setVar $init_credits $_ckinc_getInfo~credits

:buydownequip
    if ($equiproundsleft > 0)
        send "QPT"
        if ($fuelselling > 0)
            send "0*"
        end
        if ($orgselling > 0)
            send "0*"
        end
        gosub :choosehaggle
        send "L " & $_ckinc_getPlanetInfo~planet & "* tnl3*"
        subtract $equiproundsleft 1
        goto :buydownequip
    end
    if ($equiprounds > 0)
        if ($buydown_mode = "Worst Price")
            setVar $output $output & " - Equipment overhaggled at " & $overhagglemultiple & "*"
        end
    end

:buydownorg
    if ($orgroundsleft > 0)
        send "QPT"
        if ($fuelselling > 0)
            send "0*"
        end
        gosub :choosehaggle
        send "L " & $_ckinc_getPlanetInfo~planet & "* tnl2*"
        subtract $orgroundsleft 1
        goto :buydownorg
    end
    if ($orgrounds > 0)
        if ($buydown_mode = "Worst Price")
            setVar $output $output & " - Organics overhaggled at " & $overhagglemultiple & "*"
        end
    end

:buydownfuel
    if ($fuelroundsleft > 0)
        send "QPT"
        gosub :choosehaggle
        send "L " & $_ckinc_getPlanetInfo~planet & "* tnl1*"
        subtract $fuelroundsleft 1
        goto :buydownfuel
    end
    if ($fuelrounds > 0)
        if ($buydown_mode = "Worst Price")
            setVar $output $output & " - Fuel Ore overhaggled at " & $overhagglemultiple & "*"
        end
    end

:finish
    if ($location = "Citadel")
        send "C"
    else
        send "Q"
    end
    gosub :_ckinc_getInfo~getInfo
    setVar $credits_spent $init_credits
    subtract $credits_spent $_ckinc_getInfo~credits
    gosub :_ckinc_CNsettings~endCNsettings
    gosub :_ckinc_voidAdjacent~clearAdjacent
    if ($location = "Planet")
        send "L " & $_ckinc_getPlanetInfo~planet & "* "
    end
    send "'*"
#    send $scriptname & " v. " & $version & " - Buydown Complete*"
    if ($output <> "")
        send $output
    end
    send " - spent " & $credits_spent & " credits - " & $_ckinc_getInfo~turns & " turns left.*"
    send "*"
    setVar $exit_message "Normal Exit"
    goto :exit


# ----- SUB :choosehaggle
:choosehaggle
    if ($buydown_mode = "Speedbuy")
        gosub :buynohaggle
    else
        gosub :buyhaggle
    end
    return


# ----- SUB :buyhaggle
:buyhaggle
    setVar $empty $_ckinc_getInfo~holds
    send "*"
    setTextLineTrigger buyfirstoffer :buyfirstoffer "We'll sell them for"
    pause

    :buyfirstoffer
        killalltriggers
        getWord CURRENTLINE $offer 5
        striptext $offer ","

        gosub :_ckinc_swathoff~swathoff
        if ($_ckinc_swathoff~swathoff = 0)
            send "L " & $_ckinc_getPlanetInfo~planet & "* "
            if ($location = "Citadel")
                send "C "
            end
            setVar $exit_message $_ckinc_swathoff~message
            goto :exit
        end


        setVar $counter $offer
        if ($buydown_mode = "Best Price")
            multiply $counter 92
            divide $counter 100
        elseif ($buydown_mode = "Worst Price")
            multiply $counter $overhagglemultiple
            divide $counter 100
        end
        send $counter & "*"
    :buyofferloop
        setTextLineTrigger buyprice :buyprice "We'll sell them for"
        setTextLineTrigger buyfinaloffer :buyfinaloffer "Our final offer"
        setTextLineTrigger buynotinterested :buynotinterested "We're not interested."
        setTextLineTrigger buyexperience :buyexperience "experience point(s)"
        setTextLineTrigger buyempty :buyempty "empty cargo holds"
        setTextLineTrigger buyscrewup1 :buyscrewup "Get real ion-brain, make me a real offer."
        setTextLineTrigger buyscrewup2 :buyscrewup "This is the big leagues Jr.  Make a real offer."
        setTextLineTrigger buyscrewup3 :buyscrewup "My patience grows short with you."
        setTextLineTrigger buyscrewup4 :buyscrewup "I have much better things to do than waste my time.  Try again."
        setTextLineTrigger buyscrewup5 :buyscrewup "HA! HA, ha hahahhah hehehe hhhohhohohohh!  You choke me up!"
        setTextLineTrigger buyscrewup6 :buyscrewup "Quit playing around, you're wasting my time!"
        setTextLineTrigger buyscrewup7 :buyscrewup "Make a real offer or get the "
        setTextLineTrigger buyscrewup8 :buyscrewup "WHAT?!@!? you must be crazy!"
        setTextLineTrigger buyscrewup9 :buyscrewup "So, you think I'm as stupid as you look? Make a real offer."
        setTextLineTrigger buyscrewup10 :buyscrewup "What do you take me for, a fool?  Make a real offer!"
        pause
        pause
    :buyscrewup
        killalltriggers
        if ($buydown_mode = "Best Price")
            multiply $counter 102
            divide $counter 100
        elseif ($buydown_mode = "Worst Price")
            subtract $overhagglemultiple 1
            setVar $counter $offer
            multiply $counter $overhagglemultiple
            divide $counter 100
        end
        send $counter & "*"
        goto :buyofferloop
    :buyprice
        killalltriggers
        setVar $old_offer $offer
        setVar $old_counter $counter
        getWord CURRENTLINE $offer 5
        striptext $offer ","
        setVar $offer_pct $offer
        multiply $offer_pct 1000
        divide $offer_pct $old_offer
        if ($offer_pct > 990)
            setVar $offer_pct 990
        end
        multiply $counter 1000
        divide $counter $offer_pct
        if ($counter <= $old_counter)
            add $counter 1
        end
        send $counter & "*"
        goto :buyofferloop
    :buyfinaloffer
        killalltriggers
        setVar $old_offer $offer
        setVar $old_counter $counter
        getWord CURRENTLINE $offer 5
        striptext $offer ","
        setVar $offer_change $offer
        subtract $offer_change $old_offer
        subtract $offer_change 1
        multiply $offer_change 25
        divide $offer_change 10
        subtract $counter $offer_change
        if ($counter = $old_counter)
            add $counter 1
        end
        add $counter 1
        send $counter & "*"
        goto :buyofferloop
    :buynotinterested
        killalltriggers
        send "0* "
        send "0* "
        goto :buyhagglefailed
    :buyexperience
        killalltriggers
        getWord CURRENTLINE $exp_bonus 7
        add $exp $exp_bonus
        add $jetbonus $exp_bonus
        goto :buyofferloop
    :buyempty
        killalltriggers
        getWord CURRENTLINE $_ckinc_getInfo~credits 3
        stripText $_ckinc_getInfo~credits ","
        setVar $oldempty $empty
        getWord CURRENTLINE $empty 6
        if ($oldempty = $empty)
            goto :buyhagglefailed
        else
            goto :buyhagglesucceeded
        end
    :buyhagglefailed
        setVar $buyhaggle 0
        return
    :buyhagglesucceeded
        setVar $buyhaggle 1
        return


# ----- SUB :buynohaggle
:buynohaggle

    if ($_ckinc_swathoff~swathoff = 0)

        waitfor "We are selling up to"
        send "*"
        gosub :_ckinc_swathoff~swathoff
        send "*"
    else
        send "**"
    end
    add $cyclebuffer 1
    if ($cyclebuffer = $cyclebufferlimit)
        setVar $cyclebuffer 1
        send "/"
        waitfor " Sect "
    end
    return





# ----- SUB :getPortInfo -----
:getPortInfo
    send "S*CR*Q"
    setTextLineTrigger foundport :foundport "Items     Status  Trading % of max OnBoard"
    setTextLineTrigger noport :noport "I have no information about a port in that sector."
    setTextLineTrigger noport2 :noport "You have never visted sector"
    setTextLineTrigger noport3 :noport "credits / next hold"
    pause

    :noport
        killalltriggers
        if ($location <> "Citadel")
            send "L " & $_ckinc_getPlanetInfo~planet & "* "
        end
        setVar $exit_message "No port found"
        goto :exit

    :foundport
        killalltriggers
        setVar $fuelselling 0
        setVar $orgselling 0
        setVar $equipselling 0

        :getselling
            setTextLineTrigger portfuelinfo :portfuelinfo "Fuel Ore   Selling"
            setTextLineTrigger portorginfo :portorginfo "Organics   Selling"
            setTextLineTrigger portequipinfo :portequipinfo "Equipment  Selling"
            setTextLineTrigger gotallportinfo :gotallportinfo "<Computer deactivated>"
            pause

        :portfuelinfo
            killalltriggers
            getWord CURRENTLINE $fuelselling 4
            goto :getselling

        :portorginfo
            killalltriggers
            getWord CURRENTLINE $orgselling 3
            goto :getselling

        :portequipinfo
            killalltriggers
            getWord CURRENTLINE $equipselling 3
            goto :getselling

        :gotallportinfo
            killalltriggers
            return


:exit
    setvar $_ck_buydown_fuelrounds "DELETED"
    setvar $_ck_buydown_orgrounds "DELETED"
    setvar $_ck_buydown_equiprounds "DELETED"
    setvar $_ck_buydown_mode "DELETED"
    savevar $_ck_buydown_fuelrounds
    savevar $_ck_buydown_orgrounds
    savevar $_ck_buydown_equiprounds
    savevar $_ck_buydown_mode
    send "'" & $scriptname & " exiting --- " & $exit_message & "*"
    halt
	# End Script 
	# ZeD Compiled: Wed 28/08/2013 - 15:26:58.47 
# ZeD Compiled: Sat 14/09/2013 - 10:12:06.03 
